#include <blackfin.h>
#include <services_types.h>

/********************************************/
/*  Clear the CYCLES and CYCLES2 registers  */
/********************************************/
void StartProfiling ()
{
    static u32 zeroInit  = 0;

    asm ("CYCLES = %0;"::"d"(zeroInit));
    asm ("CYCLES2 = %0;"::"d"(zeroInit));
}


/********************************************/
/*  Read the CYCLES and CYCLES2 registers   */
/*  profileInfoLow <- CYCLES                */
/*  profileInfoHigh <- CYCLES2              */
/********************************************/
void EndProfiling (volatile u32 *profileInfoLow, volatile u32 *profileInfoHigh)
{
    asm ("%0 = CYCLES;":"=d"(*profileInfoLow));
    asm ("%0 = CYCLES2;":"=d"(*profileInfoHigh));
}
